diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/helper/click-internet-stack-helper.cc ns-3.40/src/click/helper/click-internet-stack-helper.cc
--- ns-3.39/src/click/helper/click-internet-stack-helper.cc	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/helper/click-internet-stack-helper.cc	2023-09-27 13:30:37.622839000 -0700
@@ -19,8 +19,6 @@
  * Author: Lalith Suresh  <suresh.lalith@gmail.com>
  */
 
-#ifdef NS3_CLICK
-
 #include "click-internet-stack-helper.h"
 
 #include "ns3/arp-l3-protocol.h"
@@ -60,13 +58,121 @@
 static InterfaceStreamMapIpv4
     g_interfaceStreamMapIpv4; /**< A mapping of Ipv4/interface pairs to ascii streams */
 
+/**
+ * IPv4 Rx / Tx packet callback.
+ *
+ * \param p Packet.
+ * \param ipv4 IPv4 stack.
+ * \param interface Interface number.
+ */
+static void
+Ipv4L3ProtocolRxTxSink(Ptr<const Packet> p, Ptr<Ipv4> ipv4, uint32_t interface)
+{
+    NS_LOG_FUNCTION(p << ipv4 << interface);
+
+    //
+    // Since trace sources are independent of interface, if we hook a source
+    // on a particular protocol we will get traces for all of its interfaces.
+    // We need to filter this to only report interfaces for which the user
+    // has expressed interest.
+    //
+    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
+    if (g_interfaceFileMapIpv4.find(pair) == g_interfaceFileMapIpv4.end())
+    {
+        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
+        return;
+    }
+
+    Ptr<PcapFileWrapper> file = g_interfaceFileMapIpv4[pair];
+    file->Write(Simulator::Now(), p);
+}
+
+/**
+ * Packet dropped callback without context.
+ *
+ * \param stream Output stream.
+ * \param header IPv4 header.
+ * \param packet Packet.
+ * \param reason Packet drop reason.
+ * \param ipv4 IPv4 stack.
+ * \param interface Interface number.
+ */
+static void
+Ipv4L3ProtocolDropSinkWithoutContext(Ptr<OutputStreamWrapper> stream,
+                                     const Ipv4Header& header,
+                                     Ptr<const Packet> packet,
+                                     Ipv4L3Protocol::DropReason reason,
+                                     Ptr<Ipv4> ipv4,
+                                     uint32_t interface)
+{
+    //
+    // Since trace sources are independent of interface, if we hook a source
+    // on a particular protocol we will get traces for all of its interfaces.
+    // We need to filter this to only report interfaces for which the user
+    // has expressed interest.
+    //
+    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
+    if (g_interfaceStreamMapIpv4.find(pair) == g_interfaceStreamMapIpv4.end())
+    {
+        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
+        return;
+    }
+
+    Ptr<Packet> p = packet->Copy();
+    p->AddHeader(header);
+    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << *p << std::endl;
+}
+
+/**
+ * Packet dropped callback with context.
+ *
+ * \param stream Output stream.
+ * \param context Context.
+ * \param header IPv4 header.
+ * \param packet Packet.
+ * \param reason Packet drop reason.
+ * \param ipv4 IPv4 stack.
+ * \param interface Interface number.
+ */
+static void
+Ipv4L3ProtocolDropSinkWithContext(Ptr<OutputStreamWrapper> stream,
+                                  std::string context,
+                                  const Ipv4Header& header,
+                                  Ptr<const Packet> packet,
+                                  Ipv4L3Protocol::DropReason reason,
+                                  Ptr<Ipv4> ipv4,
+                                  uint32_t interface)
+{
+    //
+    // Since trace sources are independent of interface, if we hook a source
+    // on a particular protocol we will get traces for all of its interfaces.
+    // We need to filter this to only report interfaces for which the user
+    // has expressed interest.
+    //
+    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
+    if (g_interfaceStreamMapIpv4.find(pair) == g_interfaceStreamMapIpv4.end())
+    {
+        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
+        return;
+    }
+
+    Ptr<Packet> p = packet->Copy();
+    p->AddHeader(header);
+#ifdef INTERFACE_CONTEXT
+    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << context << "("
+                         << interface << ") " << *p << std::endl;
+#else
+    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << context << " " << *p
+                         << std::endl;
+#endif
+}
+
 ClickInternetStackHelper::ClickInternetStackHelper()
     : m_ipv4Enabled(true)
 {
     Initialize();
 }
 
-// private method called by both constructor and Reset ()
 void
 ClickInternetStackHelper::Initialize()
 {
@@ -84,9 +190,9 @@
 ClickInternetStackHelper&
 ClickInternetStackHelper::operator=(const ClickInternetStackHelper& o)
 {
-    if (this == &o)
+    if (this != &o)
     {
-        return *this;
+        m_ipv4Enabled = o.m_ipv4Enabled;
     }
     return *this;
 }
@@ -101,7 +207,7 @@
 void
 ClickInternetStackHelper::SetClickFile(NodeContainer c, std::string clickfile)
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         SetClickFile(*i, clickfile);
     }
@@ -116,7 +222,7 @@
 void
 ClickInternetStackHelper::SetDefines(NodeContainer c, std::map<std::string, std::string> defines)
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         SetDefines(*i, defines);
     }
@@ -131,7 +237,7 @@
 void
 ClickInternetStackHelper::SetRoutingTableElement(NodeContainer c, std::string rt)
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         SetRoutingTableElement(*i, rt);
     }
@@ -146,7 +252,7 @@
 void
 ClickInternetStackHelper::Install(NodeContainer c) const
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Install(*i);
     }
@@ -190,16 +296,14 @@
         // Set routing
         Ptr<Ipv4> ipv4 = node->GetObject<Ipv4>();
         Ptr<Ipv4ClickRouting> ipv4Routing = CreateObject<Ipv4ClickRouting>();
-        std::map<Ptr<Node>, std::string>::const_iterator it;
-        it = m_nodeToClickFileMap.find(node);
+        auto it = m_nodeToClickFileMap.find(node);
 
         if (it != m_nodeToClickFileMap.end())
         {
             ipv4Routing->SetClickFile(it->second);
         }
 
-        std::map<Ptr<Node>, std::map<std::string, std::string>>::const_iterator definesIt;
-        definesIt = m_nodeToDefinesMap.find(node);
+        auto definesIt = m_nodeToDefinesMap.find(node);
         if (definesIt != m_nodeToDefinesMap.end())
         {
             ipv4Routing->SetDefines(definesIt->second);
@@ -222,34 +326,10 @@
     Install(node);
 }
 
-static void
-Ipv4L3ProtocolRxTxSink(Ptr<const Packet> p, Ptr<Ipv4> ipv4, uint32_t interface)
-{
-    NS_LOG_FUNCTION(p << ipv4 << interface);
-
-    //
-    // Since trace sources are independent of interface, if we hook a source
-    // on a particular protocol we will get traces for all of its interfaces.
-    // We need to filter this to only report interfaces for which the user
-    // has expressed interest.
-    //
-    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
-    if (g_interfaceFileMapIpv4.find(pair) == g_interfaceFileMapIpv4.end())
-    {
-        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
-        return;
-    }
-
-    Ptr<PcapFileWrapper> file = g_interfaceFileMapIpv4[pair];
-    file->Write(Simulator::Now(), p);
-}
-
 bool
 ClickInternetStackHelper::PcapHooked(Ptr<Ipv4> ipv4)
 {
-    for (InterfaceFileMapIpv4::const_iterator i = g_interfaceFileMapIpv4.begin();
-         i != g_interfaceFileMapIpv4.end();
-         ++i)
+    for (auto i = g_interfaceFileMapIpv4.begin(); i != g_interfaceFileMapIpv4.end(); ++i)
     {
         if ((*i).first.first == ipv4)
         {
@@ -322,71 +402,10 @@
     g_interfaceFileMapIpv4[std::make_pair(ipv4, interface)] = file;
 }
 
-static void
-Ipv4L3ProtocolDropSinkWithoutContext(Ptr<OutputStreamWrapper> stream,
-                                     const Ipv4Header& header,
-                                     Ptr<const Packet> packet,
-                                     Ipv4L3Protocol::DropReason reason,
-                                     Ptr<Ipv4> ipv4,
-                                     uint32_t interface)
-{
-    //
-    // Since trace sources are independent of interface, if we hook a source
-    // on a particular protocol we will get traces for all of its interfaces.
-    // We need to filter this to only report interfaces for which the user
-    // has expressed interest.
-    //
-    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
-    if (g_interfaceStreamMapIpv4.find(pair) == g_interfaceStreamMapIpv4.end())
-    {
-        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
-        return;
-    }
-
-    Ptr<Packet> p = packet->Copy();
-    p->AddHeader(header);
-    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << *p << std::endl;
-}
-
-static void
-Ipv4L3ProtocolDropSinkWithContext(Ptr<OutputStreamWrapper> stream,
-                                  std::string context,
-                                  const Ipv4Header& header,
-                                  Ptr<const Packet> packet,
-                                  Ipv4L3Protocol::DropReason reason,
-                                  Ptr<Ipv4> ipv4,
-                                  uint32_t interface)
-{
-    //
-    // Since trace sources are independent of interface, if we hook a source
-    // on a particular protocol we will get traces for all of its interfaces.
-    // We need to filter this to only report interfaces for which the user
-    // has expressed interest.
-    //
-    InterfacePairIpv4 pair = std::make_pair(ipv4, interface);
-    if (g_interfaceStreamMapIpv4.find(pair) == g_interfaceStreamMapIpv4.end())
-    {
-        NS_LOG_INFO("Ignoring packet to/from interface " << interface);
-        return;
-    }
-
-    Ptr<Packet> p = packet->Copy();
-    p->AddHeader(header);
-#ifdef INTERFACE_CONTEXT
-    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << context << "("
-                         << interface << ") " << *p << std::endl;
-#else
-    *stream->GetStream() << "d " << Simulator::Now().GetSeconds() << " " << context << " " << *p
-                         << std::endl;
-#endif
-}
-
 bool
 ClickInternetStackHelper::AsciiHooked(Ptr<Ipv4> ipv4)
 {
-    for (InterfaceStreamMapIpv4::const_iterator i = g_interfaceStreamMapIpv4.begin();
-         i != g_interfaceStreamMapIpv4.end();
-         ++i)
+    for (auto i = g_interfaceStreamMapIpv4.begin(); i != g_interfaceStreamMapIpv4.end(); ++i)
     {
         if ((*i).first.first == ipv4)
         {
@@ -521,5 +540,3 @@
 }
 
 } // namespace ns3
-
-#endif // NS3_CLICK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/helper/click-internet-stack-helper.h ns-3.40/src/click/helper/click-internet-stack-helper.h
--- ns-3.39/src/click/helper/click-internet-stack-helper.h	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/helper/click-internet-stack-helper.h	2023-09-27 13:30:37.622839000 -0700
@@ -18,8 +18,6 @@
  * Author: Lalith Suresh  <suresh.lalith@gmail.com>
  */
 
-#ifdef NS3_CLICK
-
 #ifndef CLICK_INTERNET_STACK_HELPER_H
 #define CLICK_INTERNET_STACK_HELPER_H
 
@@ -59,7 +57,20 @@
      * Destroy the ClickInternetStackHelper
      */
     ~ClickInternetStackHelper() override;
-    ClickInternetStackHelper(const ClickInternetStackHelper&);
+
+    /**
+     * Copy constructor.
+     *
+     * \param o Object to copy from.
+     */
+    ClickInternetStackHelper(const ClickInternetStackHelper& o);
+
+    /**
+     * Assignment operator.
+     *
+     * \param o Object to copy from.
+     * \return Reference to updated object.
+     */
     ClickInternetStackHelper& operator=(const ClickInternetStackHelper& o);
 
     /**
@@ -145,11 +156,12 @@
 
   private:
     /**
-     * @brief Enable pcap output the indicated Ipv4 and interface pair.
+     * \brief Enable pcap output the indicated Ipv4 and interface pair.
      *
-     * @param prefix Filename prefix to use for pcap files.
-     * @param ipv4 Ptr to the Ipv4 interface on which you want to enable tracing.
-     * @param interface Interface ID on the Ipv4 on which you want to enable tracing.
+     * \param prefix Filename prefix to use for pcap files.
+     * \param ipv4 Ptr to the Ipv4 interface on which you want to enable tracing.
+     * \param interface Interface ID on the Ipv4 on which you want to enable tracing.
+     * \param explicitFilename Whether the filename is explicit or not.
      */
     void EnablePcapIpv4Internal(std::string prefix,
                                 Ptr<Ipv4> ipv4,
@@ -157,13 +169,14 @@
                                 bool explicitFilename) override;
 
     /**
-     * @brief Enable ascii trace output on the indicated Ipv4 and interface pair.
+     * \brief Enable ascii trace output on the indicated Ipv4 and interface pair.
      *
-     * @param stream An OutputStreamWrapper representing an existing file to use
+     * \param stream An OutputStreamWrapper representing an existing file to use
      *               when writing trace data.
-     * @param prefix Filename prefix to use for ascii trace files.
-     * @param ipv4 Ptr to the Ipv4 interface on which you want to enable tracing.
-     * @param interface Interface ID on the Ipv4 on which you want to enable tracing.
+     * \param prefix Filename prefix to use for ascii trace files.
+     * \param ipv4 Ptr to the Ipv4 interface on which you want to enable tracing.
+     * \param interface Interface ID on the Ipv4 on which you want to enable tracing.
+     * \param explicitFilename Whether the filename is explicit or not.
      */
     void EnableAsciiIpv4Internal(Ptr<OutputStreamWrapper> stream,
                                  std::string prefix,
@@ -171,14 +184,34 @@
                                  uint32_t interface,
                                  bool explicitFilename) override;
 
+    /**
+     * Initialize stack helper.
+     * Called by both constructor and Reset().
+     */
     void Initialize();
 
+    /**
+     * Create and aggregate object from type ID.
+     *
+     * \param node Node.
+     * \param typeId Type ID.
+     */
     static void CreateAndAggregateObjectFromTypeId(Ptr<Node> node, const std::string typeId);
 
-    static void Cleanup();
-
+    /**
+     * Check if PCAP is hooked.
+     *
+     * \param ipv4 IPv4 stack.
+     * \return True if PCAP is hooked.
+     */
     bool PcapHooked(Ptr<Ipv4> ipv4);
 
+    /**
+     * Check if ASCII is hooked.
+     *
+     * \param ipv4 IPv4 stack.
+     * \return True if ASCII is hooked.
+     */
     bool AsciiHooked(Ptr<Ipv4> ipv4);
 
     /**
@@ -205,5 +238,3 @@
 } // namespace ns3
 
 #endif /* CLICK_INTERNET_STACK_HELPER_H */
-
-#endif /* NS3_CLICK */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/model/ipv4-click-routing.cc ns-3.40/src/click/model/ipv4-click-routing.cc
--- ns-3.39/src/click/model/ipv4-click-routing.cc	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/model/ipv4-click-routing.cc	2023-09-27 13:30:37.622839000 -0700
@@ -17,12 +17,11 @@
  * Authors: Lalith Suresh <suresh.lalith@gmail.com>
  */
 
-#ifdef NS3_CLICK
-
 #include "ipv4-click-routing.h"
 
+#include "ipv4-l3-click-protocol.h"
+
 #include "ns3/ipv4-interface.h"
-#include "ns3/ipv4-l3-click-protocol.h"
 #include "ns3/log.h"
 #include "ns3/mac48-address.h"
 #include "ns3/node.h"
@@ -87,7 +86,7 @@
         m_nodeName = name.str();
     }
 
-    NS_ASSERT(m_clickFile.length() > 0);
+    NS_ASSERT(!m_clickFile.empty());
 
     // Even though simclick_click_create() will halt programme execution
     // if it is unable to initialise a Click router, we play safe
@@ -397,7 +396,7 @@
     }
 
     int len = p->GetSize();
-    uint8_t* buf = new uint8_t[len];
+    auto buf = new uint8_t[len];
     p->CopyData(buf, len);
 
     // ... and send the packet on the corresponding Click interface.
@@ -425,7 +424,7 @@
     }
 
     int len = p->GetSize();
-    uint8_t* buf = new uint8_t[len];
+    auto buf = new uint8_t[len];
     p->CopyData(buf, len);
 
     // ... and send the packet to the corresponding Click interface
@@ -817,8 +816,8 @@
 
         // Append key/value pair, separated by \0.
         std::map<std::string, std::string> defines = clickInstance->GetDefines();
-        std::map<std::string, std::string>::const_iterator it = defines.begin();
-        while (it != defines.end())
+
+        for (auto it = defines.begin(); it != defines.end(); it++)
         {
             size_t available = *size - required;
             if (it->first.length() + it->second.length() + 2 <= available)
@@ -833,7 +832,6 @@
             {
                 required += it->first.length() + it->second.length() + 2;
             }
-            it++;
         }
         if (required > *size)
         {
@@ -850,5 +848,3 @@
     va_end(val);
     return retval;
 }
-
-#endif // NS3_CLICK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/model/ipv4-click-routing.h ns-3.40/src/click/model/ipv4-click-routing.h
--- ns-3.39/src/click/model/ipv4-click-routing.h	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/model/ipv4-click-routing.h	2023-09-27 13:30:37.622839000 -0700
@@ -54,21 +54,30 @@
  * \ingroup click
  * \brief Class to allow a node to use Click for external routing
  */
-
 class Ipv4ClickRouting : public Ipv4RoutingProtocol
 {
-#ifdef NS3_CLICK
   public:
     // Allow test cases to access private members
     friend class ::ClickTrivialTest;
     friend class ::ClickIfidFromNameTest;
     friend class ::ClickIpMacAddressFromNameTest;
 
+    /**
+     * Get type ID.
+     *
+     * \return TypeId.
+     */
     static TypeId GetTypeId();
 
+    /** Constructor. */
     Ipv4ClickRouting();
     ~Ipv4ClickRouting() override;
 
+    /**
+     * Get the uniform random variable.
+     *
+     * \return Uniform random variable.
+     */
     Ptr<UniformRandomVariable> GetRandomVariable();
 
   protected:
@@ -104,27 +113,30 @@
     /**
      * \brief Read Handler interface for a node's Click Elements.
      *        Allows a user to read state information of a Click element.
-     * \param elementName name of the Click element
-     * \param handlerName name of the handler to be read
+     * \param elementName name of the Click element.
+     * \param handlerName name of the handler to be read.
+     * \return String read.
      */
     std::string ReadHandler(std::string elementName, std::string handlerName);
 
     /**
-     * \brief Write Handler interface for a node's Click Elements
+     * \brief Write Handler interface for a node's Click Elements.
      *        Allows a user to modify state information of a Click element.
-     * \param elementName name of the Click element
-     * \param handlerName name of the handler to be read
-     * \param writeString string to be written using the write handler
+     * \param elementName name of the Click element.
+     * \param handlerName name of the handler to be read.
+     * \param writeString string to be written using the write handler.
+     * \return Write operation status.
      */
     int WriteHandler(std::string elementName, std::string handlerName, std::string writeString);
 
     /**
-     *
      * \brief Sets an interface to run on promiscuous mode.
+     * \param ifid Interface ID.
      */
     void SetPromisc(int ifid);
 
   private:
+    /// Pointer to the simclick node
     simclick_node_t* m_simNode;
 
     /**
@@ -186,6 +198,7 @@
 
     /**
      * \brief Provides for SIMCLICK_IF_READY
+     * \param ifid Interface ID
      * \return Returns 1, if the interface is ready, -1 if ifid is invalid
      */
     bool IsInterfaceReady(int ifid);
@@ -204,7 +217,8 @@
     void AddSimNodeToClickMapping();
 
     /**
-     * \brief Get current simulation time as a timeval
+     * \brief Get current simulation time as a timeval.
+     * \return Current simulation time as a timeval.
      */
     struct timeval GetTimevalFromNow() const;
 
@@ -274,20 +288,16 @@
     void NotifyRemoveAddress(uint32_t interface, Ipv4InterfaceAddress address) override;
 
   private:
-    std::string m_clickFile;
-    std::map<std::string, std::string> m_defines;
-    std::string m_nodeName;
-    std::string m_clickRoutingTableElement;
-
-    std::map<std::string, uint32_t> m_ifaceIdFromName;
-    std::map<std::string, Address> m_ifaceMacFromName;
-    std::map<std::string, Ipv4Address> m_ifaceAddrFromName;
-    bool m_clickInitialised;
-    bool m_nonDefaultName;
-
-    Ptr<Ipv4> m_ipv4;
-    Ptr<UniformRandomVariable> m_random;
-#endif /* NS3_CLICK */
+    std::string m_clickFile;                      //!< Name of .click configuration file
+    std::map<std::string, std::string> m_defines; //!< Defines for .click configuration file parsing
+    std::string m_nodeName;                       //!< Name of the node
+    std::string m_clickRoutingTableElement;       //!< Name of the routing table element
+
+    bool m_clickInitialised; //!< Whether click has been initialized
+    bool m_nonDefaultName;   //!< Whether a non-default name has been set
+
+    Ptr<Ipv4> m_ipv4;                    //!< Pointer to the IPv4 object
+    Ptr<UniformRandomVariable> m_random; //!< Uniform random variable
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/model/ipv4-l3-click-protocol.cc ns-3.40/src/click/model/ipv4-l3-click-protocol.cc
--- ns-3.39/src/click/model/ipv4-l3-click-protocol.cc	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/model/ipv4-l3-click-protocol.cc	2023-09-27 13:30:37.622839000 -0700
@@ -18,15 +18,14 @@
 // Author: Lalith Suresh <suresh.lalith@gmail.com>
 //
 
-#ifdef NS3_CLICK
-
 #include "ipv4-l3-click-protocol.h"
 
+#include "ipv4-click-routing.h"
+
 #include "ns3/arp-l3-protocol.h"
 #include "ns3/ethernet-header.h"
 #include "ns3/icmpv4-l4-protocol.h"
 #include "ns3/ip-l4-protocol.h"
-#include "ns3/ipv4-click-routing.h"
 #include "ns3/ipv4-raw-socket-impl.h"
 #include "ns3/llc-snap-header.h"
 #include "ns3/loopback-net-device.h"
@@ -80,13 +79,13 @@
 Ipv4L3ClickProtocol::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (L4List_t::iterator i = m_protocols.begin(); i != m_protocols.end(); ++i)
+    for (auto i = m_protocols.begin(); i != m_protocols.end(); ++i)
     {
         i->second = nullptr;
     }
     m_protocols.clear();
 
-    for (Ipv4InterfaceList::iterator i = m_interfaces.begin(); i != m_interfaces.end(); ++i)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); ++i)
     {
         *i = nullptr;
     }
@@ -153,8 +152,7 @@
     NS_LOG_FUNCTION(this << address);
 
     int32_t interface = 0;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end();
-         i++, interface++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
         for (uint32_t j = 0; j < (*i)->GetNAddresses(); j++)
         {
@@ -174,8 +172,7 @@
     NS_LOG_FUNCTION(this << address << mask);
 
     int32_t interface = 0;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end();
-         i++, interface++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++, interface++)
     {
         for (uint32_t j = 0; j < (*i)->GetNAddresses(); j++)
         {
@@ -194,7 +191,7 @@
 {
     NS_LOG_FUNCTION(this << device->GetIfIndex());
 
-    Ipv4InterfaceReverseContainer::const_iterator iter = m_reverseInterfacesContainer.find(device);
+    auto iter = m_reverseInterfacesContainer.find(device);
     if (iter != m_reverseInterfacesContainer.end())
     {
         return (*iter).second;
@@ -275,7 +272,7 @@
 {
     NS_LOG_FUNCTION(this << forward);
     m_ipForward = forward;
-    for (Ipv4InterfaceList::const_iterator i = m_interfaces.begin(); i != m_interfaces.end(); i++)
+    for (auto i = m_interfaces.begin(); i != m_interfaces.end(); i++)
     {
         (*i)->SetForwarding(forward);
     }
@@ -364,7 +361,7 @@
 Ipv4L3ClickProtocol::DeleteRawSocket(Ptr<Socket> socket)
 {
     NS_LOG_FUNCTION(this << socket);
-    for (SocketList::iterator i = m_sockets.begin(); i != m_sockets.end(); ++i)
+    for (auto i = m_sockets.begin(); i != m_sockets.end(); ++i)
     {
         if ((*i) == socket)
         {
@@ -805,7 +802,7 @@
         }
         packetForRawSocket->RemoveHeader(ipHeader);
 
-        for (SocketList::iterator i = m_sockets.begin(); i != m_sockets.end(); ++i)
+        for (auto i = m_sockets.begin(); i != m_sockets.end(); ++i)
         {
             NS_LOG_LOGIC("Forwarding to raw socket");
             Ptr<Ipv4RawSocketImpl> socket = *i;
@@ -923,7 +920,7 @@
     NS_LOG_FUNCTION(this << protocol);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), -1);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent default protocol "
@@ -941,7 +938,7 @@
     NS_LOG_FUNCTION(this << protocol << interfaceIndex);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), interfaceIndex);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent protocol "
@@ -968,12 +965,11 @@
     NS_LOG_FUNCTION(this << protocolNumber << interfaceIndex);
 
     L4ListKey_t key;
-    L4List_t::const_iterator i;
     if (interfaceIndex >= 0)
     {
         // try the interface-specific protocol.
         key = std::make_pair(protocolNumber, interfaceIndex);
-        i = m_protocols.find(key);
+        auto i = m_protocols.find(key);
         if (i != m_protocols.end())
         {
             return i->second;
@@ -981,7 +977,7 @@
     }
     // try the generic protocol.
     key = std::make_pair(protocolNumber, -1);
-    i = m_protocols.find(key);
+    auto i = m_protocols.find(key);
     if (i != m_protocols.end())
     {
         return i->second;
@@ -991,5 +987,3 @@
 }
 
 } // namespace ns3
-
-#endif // NS3_CLICK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/click/model/ipv4-l3-click-protocol.h ns-3.40/src/click/model/ipv4-l3-click-protocol.h
--- ns-3.39/src/click/model/ipv4-l3-click-protocol.h	2023-07-05 14:23:47.721427000 -0700
+++ ns-3.40/src/click/model/ipv4-l3-click-protocol.h	2023-09-27 13:30:37.622839000 -0700
@@ -60,8 +60,12 @@
 
 class Ipv4L3ClickProtocol : public Ipv4
 {
-#ifdef NS3_CLICK
   public:
+    /**
+     * Get Type ID.
+     *
+     * \return The type ID.
+     */
     static TypeId GetTypeId();
 
     /**
@@ -224,6 +228,12 @@
     void SetDown(uint32_t i) override;
     bool IsForwarding(uint32_t i) const override;
     void SetForwarding(uint32_t i, bool val) override;
+
+    /**
+     * Sets an interface to run on promiscuous mode.
+     *
+     * \param i Interface ID.
+     */
     void SetPromisc(uint32_t i);
 
   protected:
@@ -236,6 +246,17 @@
     void NotifyNewAggregate() override;
 
   private:
+    /**
+     * Build IPv4 header.
+     *
+     * \param source IPv4 source address.
+     * \param destination IPv4 destination address.
+     * \param protocol Protocol.
+     * \param payloadSize Payload size.
+     * \param ttl Time To Live (TTL).
+     * \param mayFragment Whether the packet can be fragmented or not.
+     * \return The IPv4 header.
+     */
     Ipv4Header BuildHeader(Ipv4Address source,
                            Ipv4Address destination,
                            uint8_t protocol,
@@ -248,32 +269,42 @@
     void SetWeakEsModel(bool model) override;
     bool GetWeakEsModel() const override;
 
+    /**
+     * \brief List of IPv4 interfaces.
+     */
     typedef std::vector<Ptr<Ipv4Interface>> Ipv4InterfaceList;
+
     /**
      * \brief Container of NetDevices registered to IPv4 and their interface indexes.
      */
     typedef std::map<Ptr<const NetDevice>, uint32_t> Ipv4InterfaceReverseContainer;
+
+    /**
+     * \brief List of sockets.
+     */
     typedef std::list<Ptr<Ipv4RawSocketImpl>> SocketList;
+
     /**
      * \brief Container of the IPv4 L4 keys: protocol number, interface index
      */
     typedef std::pair<int, int32_t> L4ListKey_t;
+
     /**
      * \brief Container of the IPv4 L4 instances.
      */
     typedef std::map<L4ListKey_t, Ptr<IpL4Protocol>> L4List_t;
 
-    Ptr<Ipv4RoutingProtocol> m_routingProtocol;
-    bool m_ipForward;
-    bool m_weakEsModel;
-    L4List_t m_protocols;
-    Ipv4InterfaceList m_interfaces;
+    Ptr<Ipv4RoutingProtocol> m_routingProtocol; //!< IPv4 routing protocol
+    bool m_ipForward;                           //!< Whether IP forwarding is enabled
+    bool m_weakEsModel;                         //!< Whether to use weak Es model
+    L4List_t m_protocols;                       //!< List of IPv4 L4 protocols
+    Ipv4InterfaceList m_interfaces;             //!< List of interfaces
     Ipv4InterfaceReverseContainer
-        m_reverseInterfacesContainer; //!< Container of NetDevice / Interface index associations.
-    uint8_t m_defaultTtl;
-    uint16_t m_identification;
+        m_reverseInterfacesContainer; //!< Container of NetDevice / Interface index associations
+    uint8_t m_defaultTtl;             //!< Default TTL
+    uint16_t m_identification;        //!< Identification
 
-    Ptr<Node> m_node;
+    Ptr<Node> m_node; //!< Node
 
     /** \todo Remove; this TracedCallback is never invoked. */
     TracedCallback<const Ipv4Header&, Ptr<const Packet>, uint32_t> m_sendOutgoingTrace;
@@ -282,11 +313,9 @@
     /** \todo This TracedCallback is invoked but not accessible. */
     TracedCallback<const Ipv4Header&, Ptr<const Packet>, uint32_t> m_localDeliverTrace;
 
-    SocketList m_sockets;
-
-    std::vector<bool> m_promiscDeviceList;
+    SocketList m_sockets; //!< List of sockets
 
-#endif /* NS3_CLICK */
+    std::vector<bool> m_promiscDeviceList; //!< List of promiscuous devices
 };
 
 } // namespace ns3
